package jalview.ws.api;

import jalview.analysis.NJTree;
import jalview.datamodel.SequenceI;
import jalview.ws.params.InvalidArgumentException;
import jalview.ws.params.WsParamSetI;

import java.io.IOError;
import java.rmi.ServerError;
import java.util.List;

public interface MsaWithGuideTreeI
{
  /**
   * Given a set of sequences
   * 
   * @param toalign
   * @param parameters
   * @return JobId or exceptions are thrown.
   */
  public JobId align(List<SequenceI> toalign, NJTree guideTree,
          WsParamSetI parameters)
          throws InvalidArgumentException, ServerError, IOError;
}