package jalview.ws.params.simple;

import jalview.ws.params.ParameterI;
import jalview.ws.params.ValueConstrainI;

/**
 * 
 * @author TZVanaalten
 *
 */
public class DoubleParameter extends Option implements ParameterI
{
  double defval;

  double min;

  double max;

  @Override
  public ValueConstrainI getValidValue()
  {
    return new ValueConstrainI()
    {
      @Override
      public ValueType getType()
      {
        return ValueType.Double;
      }

      @Override
      public Number getMin()
      {
        return min < max ? min : null;
      }

      @Override
      public Number getMax()
      {
        return min < max ? max : null;
      }
    };
  }

  public DoubleParameter(DoubleParameter parm)
  {
    super(parm);
    max = parm.max;
    min = parm.min;
  }

  public DoubleParameter(String name, String description, boolean required,
          Double defValue, double min, double max)
  {
    super(name, description, required, String.valueOf(defValue), null, null,
            null);
    defval = defValue;
    this.min = min;
    this.max = max;
  }

  public DoubleParameter(String name, String description, boolean required,
          Double defValue, Double value, double min, double max)
  {
    super(name, description, required, String.valueOf(defValue),
            String.valueOf(value), null, null);
    defval = defValue;
    this.min = min;
    this.max = max;
  }

  @Override
  public DoubleParameter copy()
  {
    return new DoubleParameter(this);
  }
}
